package edu.assistment.experiments.inclinedplane.controller;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JComboBox;

import edu.assistment.experiments.inclinedplane.model.InclinedPlaneModel;

public class RunLengthTypeController implements ActionListener
{
	private InclinedPlaneModel model;
	private JComboBox rampTypeChooser;
	
	
	public RunLengthTypeController(JComboBox combo, InclinedPlaneModel model)
	{
		this.model = model;
		rampTypeChooser = combo;
		
		rampTypeChooser.addActionListener(this);
	}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
	
	public void actionPerformed(ActionEvent e) 
	{
		// --- We'll make an assumption that the items are listed
		//     in order of "more friction"
		int index = rampTypeChooser.getSelectedIndex();
		
		model.setRunLengthFriction(.1 + .1*index);
		model.fireModelChangedEvent(null);
	}
	
}
