package edu.assistment.simulation.view;
import java.awt.BorderLayout;
import java.awt.CardLayout;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;

import javax.swing.WindowConstants;
import javax.swing.border.TitledBorder;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;
import javax.swing.text.html.HTMLEditorKit;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSpinner;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JTextPane;
import javax.swing.SpinnerListModel;
import javax.swing.SwingConstants;

/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
public class PedagogyJPanel extends javax.swing.JPanel implements KeyListener, ActionListener {
	private JScrollPane tableScroll;
	private JTextArea history;
	private JLabel agent;
	private JScrollPane textScroll;
	private JLabel middleTest;
	private JComboBox correctness;
	private JLabel conclusionsVariableValues;
	private JLabel hypothesisVariableValues;
	private JComboBox conclusionComparator;
	private JComboBox conclusionOutcomeVariable;
	private JButton conclusionSubmit;
	private JLabel middle;
	private JLabel preamble;
	private JPanel conclusionsPanel;
	private JLabel preambleText;
	private JComboBox targetVariable;
	private JPanel hypothesisPanel;
	private JButton submit;
	private JTextField commands;
	private JComboBox comparator;
	private JComboBox outcomeVariable;
	private JTable trials;

	private int line = 1;
	private String[] comparators = {"", "increase", "decrease", "stay the same"};
	private String[] variables = {"", "steepness", "surface type", "ball type", "run length"};
	private String[] variableValues = {"", "from low to high", "from smooth to rough", "from rubber to golf", "from full to half length"};
	private String[] outcomes = {"", "distance", "time"};
	private String[] correct = {"", "correct", "incorrect"};
	
	/**
	* Auto-generated main method to display this 
	* JPanel inside a new JFrame.
	*/
	public static void main(String[] args) {
		JFrame frame = new JFrame();
		frame.getContentPane().add(new PedagogyJPanel());
		frame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		frame.pack();
		frame.setVisible(true);
	}
	
	public PedagogyJPanel() {
		super();
		initGUI();
		
		commands.addKeyListener(this);
		submit.addActionListener(this);
		targetVariable.addActionListener(this);
	}
	
	private void initGUI() {
		try {
			this.setLayout(null);
			this.setPreferredSize(new java.awt.Dimension(697, 517));
			{
				tableScroll = new JScrollPane();
				{
					TableModel trialsModel = 
						new DefaultTableModel(
								new String[][] { { "1" }, { "2" }, { "3" } },
								new String[] { "Trial #", "Steepness", "Surface Type", "Ball Type", "Run Length", "Distance", "Time" });
					trials = new JTable();
					tableScroll.setViewportView(getTrials());
					trials.setModel(trialsModel);
				}
			}
			{
				commands = new JTextField();
				this.add(commands);
				commands.setText("");
				commands.setBounds(159, 460, 434, 45);
				commands.setBorder(BorderFactory.createTitledBorder("Talk to Mikey"));
			}
			{
				agent = new JLabel();
				this.add(agent);
				agent.setText("Mikey");
				agent.setIcon(new ImageIcon(getClass().getClassLoader().getResource("edu/assistment/common/view/resources/agent.jpg")));
				agent.setBounds(18, 319, 127, 184);
				agent.setVerticalTextPosition(SwingConstants.BOTTOM);
				agent.setHorizontalTextPosition(SwingConstants.CENTER);
				agent.setFont(new java.awt.Font("Comic Sans MS",1,18));
			}
			{
				submit = new JButton();
				this.add(getSubmit());
				submit.setText("Submit");
				submit.setBounds(599, 469, 86, 26);
			}
			{
				textScroll = new JScrollPane();
				this.add(getTextScroll());
				textScroll.setBounds(159, 309, 442, 145);
				textScroll.setBorder(BorderFactory.createTitledBorder("Mikey Says:"));
				{
					history = new JTextArea();
					history.setRows(999999);
					textScroll.setViewportView(history);
					history.setEditable(false);
					history.setWrapStyleWord(true);
					history.setLineWrap(true);
					this.add(tableScroll);
					tableScroll.setBounds(12, 97, 662, 103);
					tableScroll.setBorder(BorderFactory.createTitledBorder("2: Log Your Trials"));
					{
						hypothesisPanel = new JPanel();
						hypothesisPanel.setLayout(null);
						this.add(getHypothesisPanel());
						hypothesisPanel.setBounds(14, 3, 485, 89);
						hypothesisPanel.setBorder(BorderFactory.createTitledBorder("1: Form Your Hypothesis"));
						{
							ComboBoxModel targetVariableModel = new DefaultComboBoxModel(variables);
							targetVariable = new JComboBox();
							hypothesisPanel.add(getTargetVariable());
							targetVariable.setModel(targetVariableModel);
							targetVariable.setBounds(146, 19, 116, 30);
						}
						{
							preambleText = new JLabel();
							hypothesisPanel.add(preambleText);
							preambleText.setText("I think changing the ");
							preambleText.setBounds(12, 24, 134, 21);
						}
						{
							middleTest = new JLabel();
							hypothesisPanel.add(middleTest);
							middleTest.setText("will make the ");
							middleTest.setBounds(13, 59, 88, 19);
						}
						{
							ComboBoxModel outcomeVariableModel = 
								new DefaultComboBoxModel(outcomes);
							outcomeVariable = new JComboBox();
							hypothesisPanel.add(getOutcomeVariable());
							outcomeVariable.setModel(outcomeVariableModel);
							outcomeVariable.setBounds(106, 56, 108, 26);
						}
						{
							ComboBoxModel comparatorModel = 
								new DefaultComboBoxModel(comparators);
							comparator = new JComboBox();
							hypothesisPanel.add(getComparator());
							comparator.setModel(comparatorModel);
							comparator.setBounds(226, 55, 116, 26);
						}
						{
							hypothesisVariableValues = new JLabel();
							hypothesisPanel.add(getHypothesisVariableValues());
							hypothesisVariableValues.setText("");
							hypothesisVariableValues.setBounds(274, 24, 157, 19);
						}
					}
					{
						conclusionsPanel = new JPanel();
						this.add(getConclusionsPanel());
						conclusionsPanel.setBounds(12, 206, 637, 97);
						conclusionsPanel.setLayout(null);
						conclusionsPanel.setBorder(BorderFactory.createTitledBorder("3: State Your Conclusions"));
						{
							preamble = new JLabel();
							conclusionsPanel.add(getPreamble());
							preamble.setText("My experiments show that my hypothesis was ");
							preamble.setBounds(5, 29, 309, 19);
						}
						{
							ComboBoxModel correctnessModel = 
								new DefaultComboBoxModel(correct);
							correctness = new JComboBox();
							conclusionsPanel.add(getCorrectness());
							correctness.setModel(correctnessModel);
							correctness.setBounds(320, 25, 104, 26);
						}
						{
							middle = new JLabel();
							conclusionsPanel.add(middle);
							middle.setText("because the ");
							middle.setBounds(5, 61, 85, 19);
						}
						{
							ComboBoxModel jComboBox1Model = 
								new DefaultComboBoxModel(outcomes);
							conclusionOutcomeVariable = new JComboBox();
							conclusionsPanel.add(getConclusionOutcomeVariable());
							conclusionOutcomeVariable.setModel(jComboBox1Model);
							conclusionOutcomeVariable.setBounds(96, 54, 94, 26);
						}
						{
							ComboBoxModel jComboBox2Model = 
								new DefaultComboBoxModel(comparators);
							conclusionComparator = new JComboBox();
							conclusionsPanel.add(getConclusionComparator());
							conclusionComparator.setModel(jComboBox2Model);
							conclusionComparator.setBounds(196, 54, 107, 26);
						}
						{
							conclusionsVariableValues = new JLabel();
							conclusionsPanel.add(getConclusionsVariableValues());
							conclusionsVariableValues.setText("");
							conclusionsVariableValues.setBounds(315, 58, 305, 22);
						}
						{
							conclusionSubmit = new JButton();
							conclusionsPanel.add(getConclusionSubmit());
							conclusionSubmit.setText("Submit");
							conclusionSubmit.setBounds(506, 26, 114, 26);
						}
					}
					history.setText("");
					history.setBounds(404, 142, 515, 145);
					history.setEditable(false);
					history.setPreferredSize(new java.awt.Dimension(515, 145));
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public JTable getTrials() {
		return trials;
	}
	
	public JTextArea getHistory() {
		return history;
	}

	public JTextField getCommands() {
		return commands;
	}
	
	public JButton getSubmit() {
		return submit;
	}

	public void keyPressed(KeyEvent e) {
		// TODO Auto-generated method stub
		
	}

	/**
	 * Check for 'enter'. If so, treat as "Submit" button press.
	 */
	public void keyReleased(KeyEvent e) 
	{
		if(e.getKeyCode() == KeyEvent.VK_ENTER)
		{
			submit.doClick();
		}
	}

	public void keyTyped(KeyEvent e) {
		// TODO Auto-generated method stub
		
	}
	
	/**
	 * Add text to the conversation display.
	 * Who is speaking is presented in boldface
	 * 
	 * @param speaker Who is talking 
	 * @param text What they are saying.
	 */
	public void addToConversation(String speaker, String text)
	{
		if(text.equals("")) return;
		
		history.append(line + ": **" + speaker + "** says: " + text + "\n");
		line++;
	}

	/**
	 * Listen for submit button and add commands to history
	 * 
	 */
	public void actionPerformed(ActionEvent e) 
	{
		if(e.getSource() == targetVariable)
		{
			this.hypothesisVariableValues.setText(this.variableValues[targetVariable.getSelectedIndex()]);
			this.conclusionsVariableValues.setText(this.targetVariable.getSelectedItem().toString() + " " + this.variableValues[targetVariable.getSelectedIndex()]);
		}
	}
	
	public JScrollPane getTextScroll() {
		return textScroll;
	}
	
	public JPanel getHypothesisPanel() {
		return hypothesisPanel;
	}
	
	public JComboBox getTargetVariable() {
		return targetVariable;
	}
	
	public JComboBox getOutcomeVariable() {
		return outcomeVariable;
	}
	
	public JComboBox getComparator() {
		return comparator;
	}
	
	public JPanel getConclusionsPanel() {
		return conclusionsPanel;
	}
	
	public JLabel getPreamble() {
		return preamble;
	}
	
	public JComboBox getCorrectness() {
		return correctness;
	}
	
	public JComboBox getConclusionOutcomeVariable() {
		return conclusionOutcomeVariable;
	}
	
	public JComboBox getConclusionComparator() {
		return conclusionComparator;
	}
	
	public JLabel getHypothesisVariableValues() {
		return hypothesisVariableValues;
	}
	
	public JLabel getConclusionsVariableValues() {
		return conclusionsVariableValues;
	}
	
	public JButton getConclusionSubmit() {
		return conclusionSubmit;
	}

}
