package edu.assistment.experiments.inclinedplane.controller;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JComboBox;

import edu.assistment.experiments.inclinedplane.model.InclinedPlaneModel;

public class BallTypeController implements ActionListener
{
	private InclinedPlaneModel model;
	private JComboBox ballTypeChooser;
	
	
	public BallTypeController(JComboBox combo, InclinedPlaneModel model)
	{
		this.model = model;
		ballTypeChooser = combo;
		
		ballTypeChooser.addActionListener(this);
	}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
	
	public void actionPerformed(ActionEvent e) 
	{
		// --- We'll make an assumption that the items are listed
		//     in order of "more friction"
		int index = ballTypeChooser.getSelectedIndex();
		
		model.setBallMass(1.0 + 0.25*index);
		model.fireModelChangedEvent(null);
	}
	
}
